<h1>
code-edit <a href="https://npmjs.org/package/code-edit"><img src="https://img.shields.io/badge/npm-v4.0.0-F00.svg?colorA=000"/></a> <a href="src"><img src="https://img.shields.io/badge/loc-456-FFF.svg?colorA=000"/></a> <a href="https://cdn.jsdelivr.net/npm/code-edit@4.0.0/dist/code-edit.min.js"><img src="https://img.shields.io/badge/brotli-24.7K-333.svg?colorA=000"/></a> <a href="LICENSE"><img src="https://img.shields.io/badge/license-MIT-F0B.svg?colorA=000"/></a>
</h1>

<p></p>

Lightweight code editor Web Component with syntax highlighting

<h4>
<table><tr><td title="Triple click to select and copy paste">
<code>npm i code-edit </code>
</td><td title="Triple click to select and copy paste">
<code>pnpm add code-edit </code>
</td><td title="Triple click to select and copy paste">
<code>yarn add code-edit</code>
</td></tr></table>
</h4>

## Examples

<details id="example$web" title="web" open><summary><span><a href="#example$web">#</a></span>  <code><strong>web</strong></code></summary>  <ul>    <details id="source$web" title="web source code" ><summary><span><a href="#source$web">#</a></span>  <code><strong>view source</strong></code></summary>  <a href="example/web.ts">example/web.ts</a>  <p>

```ts
import 'code-syntax/themes/default.css'
import 'plenty-themes/laser.css'

import { CodeEditElement, languages } from 'code-edit'

languages.js = import('code-syntax/languages/js')
customElements.define('code-edit', CodeEditElement)

const style = document.createElement('style')
style.textContent = /*css*/ `
html,
body {
  margin: 0;
  padding: 0;
  width: 100%;
  height: 100%;
}
body {
  background: #333;
}
pre {
  color: var(--color);
  background: var(--background);
}
code-edit {
  margin: 15px;
  padding: 15px;
  width: 300px;
  height: 100px;
  font-family: monospace;
  resize: both;
}
`
document.head.appendChild(style)

document.body.innerHTML = /*html*/ `
<code-edit id="demo" autoresize autofocus language="js" theme="laser">export interface HTMLCodeEditElement {
  value?: string
  language?: string
  syntax?: SyntaxDefinition | Promise&lt;{ default: SyntaxDefinition }&gt;
  theme?: string
  tabsize?: number
  tabstyle?: 'tabs' | 'spaces'
  comments?: string
}</code-edit>
`
```

</p>
</details></ul></details>

## API

<p>  <details id="CodeEditElement$28" title="Class" ><summary><span><a href="#CodeEditElement$28">#</a></span>  <code><strong>CodeEditElement</strong></code>     &ndash; CodeEdit custom element</summary>  <a href="src/code-edit.tsx#L183">src/code-edit.tsx#L183</a>  <ul>  <p>

```js
import { CodeEditElement } from 'code-edit'
customElements.define('code-edit', CodeEditElement)
```

```html
<code-edit autofocus autoresize language="js" theme="deep"> ... </code-edit>
```

</p>
      <p>  <details id="constructor$29" title="Constructor" ><summary><span><a href="#constructor$29">#</a></span>  <code><strong>constructor</strong></code><em>()</em>    </summary>    <ul>    <p>  <details id="new CodeEditElement$30" title="ConstructorSignature" ><summary><span><a href="#new CodeEditElement$30">#</a></span>  <code><strong>new CodeEditElement</strong></code><em>()</em>    </summary>    <ul><p><a href="#CodeEditElement$28">CodeEditElement</a></p>        </ul></details></p>    </ul></details><details id="$$123" title="Property" ><summary><span><a href="#$$123">#</a></span>  <code><strong>$</strong></code>    </summary>  <a href="src/work/stagas/sigl/dist/types/sigl.d.ts#L25">src/work/stagas/sigl/dist/types/sigl.d.ts#L25</a>  <ul><p><span>Context</span>&lt;<a href="#CodeEditElement$28">CodeEditElement</a> &amp; <span>JsxContext</span>&lt;<a href="#CodeEditElement$28">CodeEditElement</a>&gt; &amp; <span>Omit</span>&lt;{<p>    <details id="ctor$127" title="Parameter" ><summary><span><a href="#ctor$127">#</a></span>  <code><strong>ctor</strong></code>    </summary>    <ul><p><span>Class</span>&lt;<a href="#T$87">T</a>&gt;</p>        </ul></details>  <p><strong></strong>&lt;<span>T</span>&gt;<em>(ctor)</em>  &nbsp;=&gt;  <ul><span>CleanClass</span>&lt;<a href="#T$87">T</a>&gt;</ul></p>  <details id="ctx$142" title="Parameter" ><summary><span><a href="#ctx$142">#</a></span>  <code><strong>ctx</strong></code>    </summary>    <ul><p><a href="#T$102">T</a> | <span>Class</span>&lt;<a href="#T$102">T</a>&gt;</p>        </ul></details>  <p><strong></strong>&lt;<span>T</span>&gt;<em>(ctx)</em>  &nbsp;=&gt;  <ul><span>Wrapper</span>&lt;<a href="#T$102">T</a>&gt;</ul></p></p>} &amp; <span>__module</span> &amp; {<p>  <details id="Boolean$146" title="Property" ><summary><span><a href="#Boolean$146">#</a></span>  <code><strong>Boolean</strong></code>    </summary>  <a href="src/work/stagas/sigl/dist/types/index.d.ts#L9">src/work/stagas/sigl/dist/types/index.d.ts#L9</a>  <ul><p>undefined | boolean</p>        </ul></details><details id="Number$145" title="Property" ><summary><span><a href="#Number$145">#</a></span>  <code><strong>Number</strong></code>    </summary>  <a href="src/work/stagas/sigl/dist/types/index.d.ts#L8">src/work/stagas/sigl/dist/types/index.d.ts#L8</a>  <ul><p>undefined | number</p>        </ul></details><details id="String$144" title="Property" ><summary><span><a href="#String$144">#</a></span>  <code><strong>String</strong></code>    </summary>  <a href="src/work/stagas/sigl/dist/types/index.d.ts#L7">src/work/stagas/sigl/dist/types/index.d.ts#L7</a>  <ul><p>undefined | string</p>        </ul></details></p>}, <code>"transition"</code>&gt;&gt;</p>        </ul></details><details id="CodeSyntax$42" title="Property" ><summary><span><a href="#CodeSyntax$42">#</a></span>  <code><strong>CodeSyntax</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>...</code></span>  </summary>  <a href="src/code-edit.tsx#L207">src/code-edit.tsx#L207</a>  <ul><p><span>Component</span>&lt;<span>CodeSyntaxElement</span>, <span>HTMLElement</span>&gt;</p>        </ul></details><details id="SuperImpose$43" title="Property" ><summary><span><a href="#SuperImpose$43">#</a></span>  <code><strong>SuperImpose</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>...</code></span>  </summary>  <a href="src/code-edit.tsx#L208">src/code-edit.tsx#L208</a>  <ul><p><span>Component</span>&lt;<span>SuperImposeElement</span>, <span>HTMLElement</span>&gt;</p>        </ul></details><details id="TextAreaCode$44" title="Property" ><summary><span><a href="#TextAreaCode$44">#</a></span>  <code><strong>TextAreaCode</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>...</code></span>  </summary>  <a href="src/code-edit.tsx#L209">src/code-edit.tsx#L209</a>  <ul><p><span>Component</span>&lt;<span>TextAreaCodeElement</span>, <span>HTMLElement</span>&gt;</p>        </ul></details><details id="TextShadow$45" title="Property" ><summary><span><a href="#TextShadow$45">#</a></span>  <code><strong>TextShadow</strong></code>    </summary>  <a href="src/code-edit.tsx#L211">src/code-edit.tsx#L211</a>  <ul><p><details id="__type$46" title="Function" ><summary><span><a href="#__type$46">#</a></span>  <em>({ x, y })</em>    </summary>    <ul>    <p>    <details id="props$48" title="Parameter" ><summary><span><a href="#props$48">#</a></span>  <code><strong>props</strong></code>    </summary>    <ul><p>{<p>  <details id="x$50" title="Property" ><summary><span><a href="#x$50">#</a></span>  <code><strong>x</strong></code>    </summary>  <a href="src/code-edit.tsx#L211">src/code-edit.tsx#L211</a>  <ul><p>number</p>        </ul></details><details id="y$51" title="Property" ><summary><span><a href="#y$51">#</a></span>  <code><strong>y</strong></code>    </summary>  <a href="src/code-edit.tsx#L211">src/code-edit.tsx#L211</a>  <ul><p>number</p>        </ul></details></p>}</p>        </ul></details>  <p><strong></strong><em>({ x, y })</em>  &nbsp;=&gt;  <ul><span>VKid</span></ul></p></p>    </ul></details></p>        </ul></details><details id="autoFocus$33" title="Property" ><summary><span><a href="#autoFocus$33">#</a></span>  <code><strong>autoFocus</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>false</code></span>   &ndash; Autofocus to the element when page loads</summary>  <a href="src/code-edit.tsx#L189">src/code-edit.tsx#L189</a>  <ul><p>boolean</p>        </ul></details><details id="autoResize$34" title="Property" ><summary><span><a href="#autoResize$34">#</a></span>  <code><strong>autoResize</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>false</code></span>   &ndash; Whether to autoresize to the height of the contents</summary>  <a href="src/code-edit.tsx#L191">src/code-edit.tsx#L191</a>  <ul><p>boolean</p>        </ul></details><details id="caretBlink$77" title="Property" ><summary><span><a href="#caretBlink$77">#</a></span>  <code><strong>caretBlink</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>'none'</code></span>  </summary>  <a href="src/code-edit.tsx#L259">src/code-edit.tsx#L259</a>  <ul><p><code>"blink"</code> | <code>"none"</code></p>        </ul></details><details id="caretBlinkTimeout$78" title="Property" ><summary><span><a href="#caretBlinkTimeout$78">#</a></span>  <code><strong>caretBlinkTimeout</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>-1</code></span>  </summary>  <a href="src/code-edit.tsx#L260">src/code-edit.tsx#L260</a>  <ul><p>any</p>        </ul></details><details id="caretIndex$75" title="Property" ><summary><span><a href="#caretIndex$75">#</a></span>  <code><strong>caretIndex</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>0</code></span>  </summary>  <a href="src/code-edit.tsx#L257">src/code-edit.tsx#L257</a>  <ul><p>number</p>        </ul></details><details id="caretShift$76" title="Property" ><summary><span><a href="#caretShift$76">#</a></span>  <code><strong>caretShift</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>'none'</code></span>  </summary>  <a href="src/code-edit.tsx#L258">src/code-edit.tsx#L258</a>  <ul><p><code>"forward"</code> | <code>"backward"</code> | <code>"none"</code></p>        </ul></details><details id="comments$39" title="Property" ><summary><span><a href="#comments$39">#</a></span>  <code><strong>comments</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>'// /* */'</code></span>   &ndash; Comment</summary>  <a href="src/code-edit.tsx#L201">src/code-edit.tsx#L201</a>  <ul><p>string</p>        </ul></details><details id="context$147" title="Property" ><summary><span><a href="#context$147">#</a></span>  <code><strong>context</strong></code>    </summary>  <a href="src/work/stagas/sigl/dist/types/sigl.d.ts#L26">src/work/stagas/sigl/dist/types/sigl.d.ts#L26</a>  <ul><p><span>ContextClass</span>&lt;<a href="#CodeEditElement$28">CodeEditElement</a> &amp; <span>JsxContext</span>&lt;<a href="#CodeEditElement$28">CodeEditElement</a>&gt; &amp; <span>Omit</span>&lt;{<p>    <details id="ctor$151" title="Parameter" ><summary><span><a href="#ctor$151">#</a></span>  <code><strong>ctor</strong></code>    </summary>    <ul><p><span>Class</span>&lt;<a href="#T$87">T</a>&gt;</p>        </ul></details>  <p><strong></strong>&lt;<span>T</span>&gt;<em>(ctor)</em>  &nbsp;=&gt;  <ul><span>CleanClass</span>&lt;<a href="#T$87">T</a>&gt;</ul></p>  <details id="ctx$166" title="Parameter" ><summary><span><a href="#ctx$166">#</a></span>  <code><strong>ctx</strong></code>    </summary>    <ul><p><a href="#T$102">T</a> | <span>Class</span>&lt;<a href="#T$102">T</a>&gt;</p>        </ul></details>  <p><strong></strong>&lt;<span>T</span>&gt;<em>(ctx)</em>  &nbsp;=&gt;  <ul><span>Wrapper</span>&lt;<a href="#T$102">T</a>&gt;</ul></p></p>} &amp; <span>__module</span> &amp; {<p>  <details id="Boolean$170" title="Property" ><summary><span><a href="#Boolean$170">#</a></span>  <code><strong>Boolean</strong></code>    </summary>  <a href="src/work/stagas/sigl/dist/types/index.d.ts#L9">src/work/stagas/sigl/dist/types/index.d.ts#L9</a>  <ul><p>undefined | boolean</p>        </ul></details><details id="Number$169" title="Property" ><summary><span><a href="#Number$169">#</a></span>  <code><strong>Number</strong></code>    </summary>  <a href="src/work/stagas/sigl/dist/types/index.d.ts#L8">src/work/stagas/sigl/dist/types/index.d.ts#L8</a>  <ul><p>undefined | number</p>        </ul></details><details id="String$168" title="Property" ><summary><span><a href="#String$168">#</a></span>  <code><strong>String</strong></code>    </summary>  <a href="src/work/stagas/sigl/dist/types/index.d.ts#L7">src/work/stagas/sigl/dist/types/index.d.ts#L7</a>  <ul><p>undefined | string</p>        </ul></details></p>}, <code>"transition"</code>&gt;&gt;</p>        </ul></details><details id="dispatch$108" title="Property" ><summary><span><a href="#dispatch$108">#</a></span>  <code><strong>dispatch</strong></code>    </summary>  <a href="src/work/stagas/sigl/dist/types/events.d.ts#L4">src/work/stagas/sigl/dist/types/events.d.ts#L4</a>  <ul><p><span>Dispatch</span>&lt;<details id="__type$109" title="Function" ><summary><span><a href="#__type$109">#</a></span>  <em>(name, detail, init)</em>    </summary>    <ul>    <p>    <details id="name$113" title="Parameter" ><summary><span><a href="#name$113">#</a></span>  <code><strong>name</strong></code>    </summary>    <ul><p><span>Event</span> | <span>Narrow</span>&lt;<a href="#K$111">K</a>, string&gt;</p>        </ul></details><details id="detail$114" title="Parameter" ><summary><span><a href="#detail$114">#</a></span>  <code><strong>detail</strong></code>    </summary>    <ul><p><a href="#E$112">E</a></p>        </ul></details><details id="init$115" title="Parameter" ><summary><span><a href="#init$115">#</a></span>  <code><strong>init</strong></code>    </summary>    <ul><p><span>CustomEventInit</span>&lt;any&gt;</p>        </ul></details>  <p><strong></strong>&lt;<span>K</span>, <span>E</span>&gt;<em>(name, detail, init)</em>  &nbsp;=&gt;  <ul>any</ul></p></p>    </ul></details>&gt;</p>        </ul></details><details id="fontSize$32" title="Property" ><summary><span><a href="#fontSize$32">#</a></span>  <code><strong>fontSize</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>9.5</code></span>   &ndash; Font size</summary>  <a href="src/code-edit.tsx#L187">src/code-edit.tsx#L187</a>  <ul><p>number</p>        </ul></details><details id="hasFocus$41" title="Property" ><summary><span><a href="#hasFocus$41">#</a></span>  <code><strong>hasFocus</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>false</code></span>  </summary>  <a href="src/code-edit.tsx#L205">src/code-edit.tsx#L205</a>  <ul><p>boolean</p>        </ul></details><details id="height$55" title="Property" ><summary><span><a href="#height$55">#</a></span>  <code><strong>height</strong></code>    </summary>  <a href="src/code-edit.tsx#L218">src/code-edit.tsx#L218</a>  <ul><p><span>HTMLPreElement</span></p>        </ul></details><details id="host$122" title="Property" ><summary><span><a href="#host$122">#</a></span>  <code><strong>host</strong></code>    </summary>  <a href="src/work/stagas/sigl/dist/types/sigl.d.ts#L24">src/work/stagas/sigl/dist/types/sigl.d.ts#L24</a>  <ul><p><a href="#CodeEditElement$28">CodeEditElement</a></p>        </ul></details><details id="hoveringMarker$61" title="Property" ><summary><span><a href="#hoveringMarker$61">#</a></span>  <code><strong>hoveringMarker</strong></code>    </summary>  <a href="src/code-edit.tsx#L223">src/code-edit.tsx#L223</a>  <ul><p><code>null</code> | <a href="#Marker$5">Marker</a></p>        </ul></details><details id="language$35" title="Property" ><summary><span><a href="#language$35">#</a></span>  <code><strong>language</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>''</code></span>   &ndash; Language for syntax highlighting</summary>  <a href="src/code-edit.tsx#L193">src/code-edit.tsx#L193</a>  <ul><p>string</p>        </ul></details><details id="layout$54" title="Property" ><summary><span><a href="#layout$54">#</a></span>  <code><strong>layout</strong></code>    </summary>  <a href="src/code-edit.tsx#L217">src/code-edit.tsx#L217</a>  <ul><p><span>SuperImposeElement</span></p>        </ul></details><details id="lenses$62" title="Property" ><summary><span><a href="#lenses$62">#</a></span>  <code><strong>lenses</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>[]</code></span>   &ndash; Lens</summary>  <a href="src/code-edit.tsx#L226">src/code-edit.tsx#L226</a>  <ul><p><a href="#Lens$24">Lens</a>  []</p>        </ul></details><details id="markers$56" title="Property" ><summary><span><a href="#markers$56">#</a></span>  <code><strong>markers</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>[]</code></span>   &ndash; Custom markers</summary>  <a href="src/code-edit.tsx#L221">src/code-edit.tsx#L221</a>  <ul><p><a href="#Marker$5">Marker</a>  []</p>        </ul></details><details id="markersCss$57" title="Property" ><summary><span><a href="#markersCss$57">#</a></span>  <code><strong>markersCss</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>...</code></span>  </summary>  <a href="src/code-edit.tsx#L222">src/code-edit.tsx#L222</a>  <ul><p><details id="__type$58" title="Function" ><summary><span><a href="#__type$58">#</a></span>  <em>(selector)</em>    </summary>    <ul>    <p>    <details id="selector$60" title="Parameter" ><summary><span><a href="#selector$60">#</a></span>  <code><strong>selector</strong></code>    </summary>    <ul><p>string</p>        </ul></details>  <p><strong></strong><em>(selector)</em>  &nbsp;=&gt;  <ul>string</ul></p></p>    </ul></details></p>        </ul></details><details id="onInput$68" title="Property" ><summary><span><a href="#onInput$68">#</a></span>  <code><strong>onInput</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>...</code></span>  </summary>  <a href="src/code-edit.tsx#L237">src/code-edit.tsx#L237</a>  <ul><p><details id="__type$69" title="Function" ><summary><span><a href="#__type$69">#</a></span>  <em>()</em>    </summary>    <ul>    <p>      <p><strong></strong><em>()</em>  &nbsp;=&gt;  <ul>void</ul></p></p>    </ul></details></p>        </ul></details><details id="onScroll$71" title="Property" ><summary><span><a href="#onScroll$71">#</a></span>  <code><strong>onScroll</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>...</code></span>  </summary>  <a href="src/code-edit.tsx#L243">src/code-edit.tsx#L243</a>  <ul><p><details id="__type$72" title="Function" ><summary><span><a href="#__type$72">#</a></span>  <em>()</em>    </summary>    <ul>    <p>      <p><strong></strong><em>()</em>  &nbsp;=&gt;  <ul>void</ul></p></p>    </ul></details></p>        </ul></details><details id="onWheel$74" title="Property" ><summary><span><a href="#onWheel$74">#</a></span>  <code><strong>onWheel</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>...</code></span>  </summary>  <a href="src/code-edit.tsx#L247">src/code-edit.tsx#L247</a>  <ul><p><span>EventHandler</span>&lt;<span>SuperImposeElement</span>, <span>WheelEvent</span>&gt;</p>        </ul></details><details id="onmounted$120" title="Property" ><summary><span><a href="#onmounted$120">#</a></span>  <code><strong>onmounted</strong></code>    </summary>    <ul><p><span>EventHandler</span>&lt;<a href="#CodeEditElement$28">CodeEditElement</a>, <span>CustomEvent</span>&lt;any&gt;&gt;</p>        </ul></details><details id="onunmounted$121" title="Property" ><summary><span><a href="#onunmounted$121">#</a></span>  <code><strong>onunmounted</strong></code>    </summary>    <ul><p><span>EventHandler</span>&lt;<a href="#CodeEditElement$28">CodeEditElement</a>, <span>CustomEvent</span>&lt;any&gt;&gt;</p>        </ul></details><details id="root$63" title="Property" ><summary><span><a href="#root$63">#</a></span>  <code><strong>root</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>...</code></span>  </summary>  <a href="src/code-edit.tsx#L228">src/code-edit.tsx#L228</a>  <ul><p><span>ShadowRoot</span></p>        </ul></details><details id="syntax$52" title="Property" ><summary><span><a href="#syntax$52">#</a></span>  <code><strong>syntax</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>{}</code></span>   &ndash; Passing a syntax definition regexp manually</summary>  <a href="src/code-edit.tsx#L214">src/code-edit.tsx#L214</a>  <ul><p><a href="#SyntaxOrImport$2">SyntaxOrImport</a></p>        </ul></details><details id="tabSize$37" title="Property" ><summary><span><a href="#tabSize$37">#</a></span>  <code><strong>tabSize</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>2</code></span>   &ndash; Tab size</summary>  <a href="src/code-edit.tsx#L197">src/code-edit.tsx#L197</a>  <ul><p>number</p>        </ul></details><details id="tabStyle$38" title="Property" ><summary><span><a href="#tabStyle$38">#</a></span>  <code><strong>tabStyle</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>'spaces'</code></span>   &ndash; Tab style</summary>  <a href="src/code-edit.tsx#L199">src/code-edit.tsx#L199</a>  <ul><p><code>"spaces"</code> | <code>"tabs"</code></p>        </ul></details><details id="textShadow$40" title="Property" ><summary><span><a href="#textShadow$40">#</a></span>  <code><strong>textShadow</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>false</code></span>   &ndash; Shadow</summary>  <a href="src/code-edit.tsx#L203">src/code-edit.tsx#L203</a>  <ul><p>boolean</p>        </ul></details><details id="textarea$53" title="Property" ><summary><span><a href="#textarea$53">#</a></span>  <code><strong>textarea</strong></code>    </summary>  <a href="src/code-edit.tsx#L216">src/code-edit.tsx#L216</a>  <ul><p><span>TextAreaCodeElement</span></p>        </ul></details><details id="theme$36" title="Property" ><summary><span><a href="#theme$36">#</a></span>  <code><strong>theme</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>''</code></span>   &ndash; Theme to use</summary>  <a href="src/code-edit.tsx#L195">src/code-edit.tsx#L195</a>  <ul><p>string</p>        </ul></details><details id="updateCaret$79" title="Property" ><summary><span><a href="#updateCaret$79">#</a></span>  <code><strong>updateCaret</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>...</code></span>  </summary>  <a href="src/code-edit.tsx#L262">src/code-edit.tsx#L262</a>  <ul><p><details id="__type$80" title="Function" ><summary><span><a href="#__type$80">#</a></span>  <em>()</em>    </summary>    <ul>    <p>      <p><strong></strong><em>()</em>  &nbsp;=&gt;  <ul>void</ul></p></p>    </ul></details></p>        </ul></details><details id="value$31" title="Property" ><summary><span><a href="#value$31">#</a></span>  <code><strong>value</strong></code>  <span><span>&nbsp;=&nbsp;</span>  <code>''</code></span>   &ndash; The editor's value</summary>  <a href="src/code-edit.tsx#L185">src/code-edit.tsx#L185</a>  <ul><p>string</p>        </ul></details><details id="scrollLeft$64" title="Accessor" ><summary><span><a href="#scrollLeft$64">#</a></span>  <code><strong>scrollLeft</strong></code>    </summary>  <a href="src/code-edit.tsx#L230">src/code-edit.tsx#L230</a>  <ul>        </ul></details><details id="scrollTop$66" title="Accessor" ><summary><span><a href="#scrollTop$66">#</a></span>  <code><strong>scrollTop</strong></code>    </summary>  <a href="src/code-edit.tsx#L233">src/code-edit.tsx#L233</a>  <ul>        </ul></details><details id="created$171" title="Method" ><summary><span><a href="#created$171">#</a></span>  <code><strong>created</strong></code><em>(ctx)</em>    </summary>    <ul>    <p>    <details id="ctx$173" title="Parameter" ><summary><span><a href="#ctx$173">#</a></span>  <code><strong>ctx</strong></code>    </summary>    <ul><p><span>Context</span>&lt;<a href="#CodeEditElement$28">CodeEditElement</a> &amp; <span>JsxContext</span>&lt;<a href="#CodeEditElement$28">CodeEditElement</a>&gt; &amp; <span>Omit</span>&lt;{<p>    <details id="ctor$177" title="Parameter" ><summary><span><a href="#ctor$177">#</a></span>  <code><strong>ctor</strong></code>    </summary>    <ul><p><span>Class</span>&lt;<a href="#T$87">T</a>&gt;</p>        </ul></details>  <p><strong></strong>&lt;<span>T</span>&gt;<em>(ctor)</em>  &nbsp;=&gt;  <ul><span>CleanClass</span>&lt;<a href="#T$87">T</a>&gt;</ul></p>  <details id="ctx$192" title="Parameter" ><summary><span><a href="#ctx$192">#</a></span>  <code><strong>ctx</strong></code>    </summary>    <ul><p><a href="#T$102">T</a> | <span>Class</span>&lt;<a href="#T$102">T</a>&gt;</p>        </ul></details>  <p><strong></strong>&lt;<span>T</span>&gt;<em>(ctx)</em>  &nbsp;=&gt;  <ul><span>Wrapper</span>&lt;<a href="#T$102">T</a>&gt;</ul></p></p>} &amp; <span>__module</span> &amp; {<p>  <details id="Boolean$196" title="Property" ><summary><span><a href="#Boolean$196">#</a></span>  <code><strong>Boolean</strong></code>    </summary>  <a href="src/work/stagas/sigl/dist/types/index.d.ts#L9">src/work/stagas/sigl/dist/types/index.d.ts#L9</a>  <ul><p>undefined | boolean</p>        </ul></details><details id="Number$195" title="Property" ><summary><span><a href="#Number$195">#</a></span>  <code><strong>Number</strong></code>    </summary>  <a href="src/work/stagas/sigl/dist/types/index.d.ts#L8">src/work/stagas/sigl/dist/types/index.d.ts#L8</a>  <ul><p>undefined | number</p>        </ul></details><details id="String$194" title="Property" ><summary><span><a href="#String$194">#</a></span>  <code><strong>String</strong></code>    </summary>  <a href="src/work/stagas/sigl/dist/types/index.d.ts#L7">src/work/stagas/sigl/dist/types/index.d.ts#L7</a>  <ul><p>undefined | string</p>        </ul></details></p>}, <code>"transition"</code>&gt;&gt;</p>        </ul></details>  <p><strong>created</strong><em>(ctx)</em>  &nbsp;=&gt;  <ul>void</ul></p></p>    </ul></details><details id="mounted$82" title="Method" ><summary><span><a href="#mounted$82">#</a></span>  <code><strong>mounted</strong></code><em>($)</em>    </summary>  <a href="src/code-edit.tsx#L279">src/code-edit.tsx#L279</a>  <ul>    <p>    <details id="$$84" title="Parameter" ><summary><span><a href="#$$84">#</a></span>  <code><strong>$</strong></code>    </summary>    <ul><p><span>Context</span>&lt;<a href="#CodeEditElement$28">CodeEditElement</a> &amp; <span>JsxContext</span>&lt;<a href="#CodeEditElement$28">CodeEditElement</a>&gt; &amp; <span>Omit</span>&lt;{<p>    <details id="ctor$88" title="Parameter" ><summary><span><a href="#ctor$88">#</a></span>  <code><strong>ctor</strong></code>    </summary>    <ul><p><span>Class</span>&lt;<a href="#T$87">T</a>&gt;</p>        </ul></details>  <p><strong></strong>&lt;<span>T</span>&gt;<em>(ctor)</em>  &nbsp;=&gt;  <ul><span>CleanClass</span>&lt;<a href="#T$87">T</a>&gt;</ul></p>  <details id="ctx$103" title="Parameter" ><summary><span><a href="#ctx$103">#</a></span>  <code><strong>ctx</strong></code>    </summary>    <ul><p><a href="#T$102">T</a> | <span>Class</span>&lt;<a href="#T$102">T</a>&gt;</p>        </ul></details>  <p><strong></strong>&lt;<span>T</span>&gt;<em>(ctx)</em>  &nbsp;=&gt;  <ul><span>Wrapper</span>&lt;<a href="#T$102">T</a>&gt;</ul></p></p>} &amp; <span>__module</span> &amp; {<p>  <details id="Boolean$107" title="Property" ><summary><span><a href="#Boolean$107">#</a></span>  <code><strong>Boolean</strong></code>    </summary>  <a href="src/work/stagas/sigl/dist/types/index.d.ts#L9">src/work/stagas/sigl/dist/types/index.d.ts#L9</a>  <ul><p>undefined | boolean</p>        </ul></details><details id="Number$106" title="Property" ><summary><span><a href="#Number$106">#</a></span>  <code><strong>Number</strong></code>    </summary>  <a href="src/work/stagas/sigl/dist/types/index.d.ts#L8">src/work/stagas/sigl/dist/types/index.d.ts#L8</a>  <ul><p>undefined | number</p>        </ul></details><details id="String$105" title="Property" ><summary><span><a href="#String$105">#</a></span>  <code><strong>String</strong></code>    </summary>  <a href="src/work/stagas/sigl/dist/types/index.d.ts#L7">src/work/stagas/sigl/dist/types/index.d.ts#L7</a>  <ul><p>undefined | string</p>        </ul></details></p>}, <code>"transition"</code>&gt;&gt;</p>        </ul></details>  <p><strong>mounted</strong><em>($)</em>  &nbsp;=&gt;  <ul>void</ul></p></p>    </ul></details><details id="on$116" title="Method" ><summary><span><a href="#on$116">#</a></span>  <code><strong>on</strong></code><em>(name)</em>    </summary>    <ul>    <p>    <details id="name$119" title="Parameter" ><summary><span><a href="#name$119">#</a></span>  <code><strong>name</strong></code>    </summary>    <ul><p><a href="#K$118">K</a></p>        </ul></details>  <p><strong>on</strong>&lt;<span>K</span>&gt;<em>(name)</em>  &nbsp;=&gt;  <ul><span>On</span>&lt;<span>Fn</span>&lt;[  <span>EventHandler</span>&lt;<a href="#CodeEditElement$28">CodeEditElement</a>, <span>LifecycleEvents</span> &amp; object  [<a href="#K$118">K</a>]&gt;  ], <span>Off</span>&gt;&gt;</ul></p></p>    </ul></details><details id="toJSON$197" title="Method" ><summary><span><a href="#toJSON$197">#</a></span>  <code><strong>toJSON</strong></code><em>()</em>    </summary>    <ul>    <p>      <p><strong>toJSON</strong><em>()</em>  &nbsp;=&gt;  <ul><span>Pick</span>&lt;<a href="#CodeEditElement$28">CodeEditElement</a>, keyof     <a href="#CodeEditElement$28">CodeEditElement</a>&gt;</ul></p></p>    </ul></details></p></ul></details><details id="Lens$24" title="TypeAlias" ><summary><span><a href="#Lens$24">#</a></span>  <code><strong>Lens</strong></code>    </summary>  <a href="src/code-edit.tsx#L37">src/code-edit.tsx#L37</a>  <ul><p>{<p>  <details id="line$26" title="Property" ><summary><span><a href="#line$26">#</a></span>  <code><strong>line</strong></code>    </summary>  <a href="src/code-edit.tsx#L38">src/code-edit.tsx#L38</a>  <ul><p>number</p>        </ul></details><details id="message$27" title="Property" ><summary><span><a href="#message$27">#</a></span>  <code><strong>message</strong></code>    </summary>  <a href="src/code-edit.tsx#L39">src/code-edit.tsx#L39</a>  <ul><p>string</p>        </ul></details></p>}</p>        </ul></details><details id="Marker$5" title="TypeAlias" ><summary><span><a href="#Marker$5">#</a></span>  <code><strong>Marker</strong></code>    </summary>  <a href="src/code-edit.tsx#L23">src/code-edit.tsx#L23</a>  <ul><p>{<p>  <details id="class$11" title="Property" ><summary><span><a href="#class$11">#</a></span>  <code><strong>class</strong></code>    </summary>  <a href="src/code-edit.tsx#L28">src/code-edit.tsx#L28</a>  <ul><p>string</p>        </ul></details><details id="el$12" title="Property" ><summary><span><a href="#el$12">#</a></span>  <code><strong>el</strong></code>    </summary>  <a href="src/code-edit.tsx#L29">src/code-edit.tsx#L29</a>  <ul><p><span>HTMLSpanElement</span></p>        </ul></details><details id="index$8" title="Property" ><summary><span><a href="#index$8">#</a></span>  <code><strong>index</strong></code>    </summary>  <a href="src/code-edit.tsx#L25">src/code-edit.tsx#L25</a>  <ul><p>number</p>        </ul></details><details id="key$7" title="Property" ><summary><span><a href="#key$7">#</a></span>  <code><strong>key</strong></code>    </summary>  <a href="src/code-edit.tsx#L24">src/code-edit.tsx#L24</a>  <ul><p>string</p>        </ul></details><details id="onwheel$23" title="Property" ><summary><span><a href="#onwheel$23">#</a></span>  <code><strong>onwheel</strong></code>    </summary>  <a href="src/code-edit.tsx#L34">src/code-edit.tsx#L34</a>  <ul><p><span>$.EventHandler</span>&lt;any, <span>WheelEvent</span>&gt;</p>        </ul></details><details id="rect$13" title="Property" ><summary><span><a href="#rect$13">#</a></span>  <code><strong>rect</strong></code>    </summary>  <a href="src/code-edit.tsx#L30">src/code-edit.tsx#L30</a>  <ul><p><span>DOMRect</span></p>        </ul></details><details id="size$9" title="Property" ><summary><span><a href="#size$9">#</a></span>  <code><strong>size</strong></code>    </summary>  <a href="src/code-edit.tsx#L26">src/code-edit.tsx#L26</a>  <ul><p>number</p>        </ul></details><details id="source$10" title="Property" ><summary><span><a href="#source$10">#</a></span>  <code><strong>source</strong></code>    </summary>  <a href="src/code-edit.tsx#L27">src/code-edit.tsx#L27</a>  <ul><p>string</p>        </ul></details><details id="oncreate$14" title="Method" ><summary><span><a href="#oncreate$14">#</a></span>  <code><strong>oncreate</strong></code><em>(el)</em>    </summary>  <a href="src/code-edit.tsx#L31">src/code-edit.tsx#L31</a>  <ul>    <p>    <details id="el$16" title="Parameter" ><summary><span><a href="#el$16">#</a></span>  <code><strong>el</strong></code>    </summary>    <ul><p><span>HTMLSpanElement</span></p>        </ul></details>  <p><strong>oncreate</strong><em>(el)</em>  &nbsp;=&gt;  <ul>void</ul></p></p>    </ul></details><details id="onenter$17" title="Method" ><summary><span><a href="#onenter$17">#</a></span>  <code><strong>onenter</strong></code><em>(el)</em>    </summary>  <a href="src/code-edit.tsx#L32">src/code-edit.tsx#L32</a>  <ul>    <p>    <details id="el$19" title="Parameter" ><summary><span><a href="#el$19">#</a></span>  <code><strong>el</strong></code>    </summary>    <ul><p><span>HTMLSpanElement</span></p>        </ul></details>  <p><strong>onenter</strong><em>(el)</em>  &nbsp;=&gt;  <ul>void</ul></p></p>    </ul></details><details id="onleave$20" title="Method" ><summary><span><a href="#onleave$20">#</a></span>  <code><strong>onleave</strong></code><em>(el)</em>    </summary>  <a href="src/code-edit.tsx#L33">src/code-edit.tsx#L33</a>  <ul>    <p>    <details id="el$22" title="Parameter" ><summary><span><a href="#el$22">#</a></span>  <code><strong>el</strong></code>    </summary>    <ul><p><span>HTMLSpanElement</span></p>        </ul></details>  <p><strong>onleave</strong><em>(el)</em>  &nbsp;=&gt;  <ul>void</ul></p></p>    </ul></details></p>}</p>        </ul></details><details id="SyntaxOrImport$2" title="TypeAlias" ><summary><span><a href="#SyntaxOrImport$2">#</a></span>  <code><strong>SyntaxOrImport</strong></code>    </summary>  <a href="src/work/stagas/code-syntax/dist/types/syntax.d.ts#L9">src/work/stagas/code-syntax/dist/types/syntax.d.ts#L9</a>  <ul><p><span>SyntaxDefinition</span> | <span>Promise</span>&lt;{<p>  <details id="default$4" title="Property" ><summary><span><a href="#default$4">#</a></span>  <code><strong>default</strong></code>    </summary>  <a href="src/work/stagas/code-syntax/dist/types/syntax.d.ts#L10">src/work/stagas/code-syntax/dist/types/syntax.d.ts#L10</a>  <ul><p><span>SyntaxDefinition</span></p>        </ul></details></p>}&gt;</p>        </ul></details><details id="languages$1" title="Variable" ><summary><span><a href="#languages$1">#</a></span>  <code><strong>languages</strong></code>    </summary>  <a href="src/work/stagas/code-syntax/dist/types/element.d.ts#L4">src/work/stagas/code-syntax/dist/types/element.d.ts#L4</a>  <ul><p><span>Record</span>&lt;string, <a href="#SyntaxOrImport$2">SyntaxOrImport</a>&gt;</p>        </ul></details></p>

## Credits

- [code-syntax](https://npmjs.org/package/code-syntax) by [stagas](https://github.com/stagas) &ndash; Code syntax highlight Web Component
- [get-element-offset](https://npmjs.org/package/get-element-offset) by [stagas](https://github.com/stagas) &ndash; Get accurate DOM element offset.
- [relative-mouse](https://npmjs.org/package/relative-mouse) by [stagas](https://github.com/stagas) &ndash; Get mouse position relative to a DOM element.
- [sigl](https://npmjs.org/package/sigl) by [stagas](https://github.com/stagas) &ndash; Web framework
- [super-impose](https://npmjs.org/package/super-impose) by [stagas](https://github.com/stagas) &ndash; Web Component that super imposes one child over another to the same scroll position
- [textarea-code](https://npmjs.org/package/textarea-code) by [stagas](https://github.com/stagas) &ndash; Web Component that extends a textarea element with code editor behavior.

## Contributing

[Fork](https://github.com/stagas/code-edit/fork) or [edit](https://github.dev/stagas/code-edit) and submit a PR.

All contributions are welcome!

## License

<a href="LICENSE">MIT</a> &copy; 2022 [stagas](https://github.com/stagas)
